// #autoload
// #name = _ZLakHUD
// #category = ZephyrFox's Scripts
// #description = Point HUD for LakRabbit bonus shots.
// #version = 1.5
// #date = 09.10.2003
// #status = finished
// #author = Anthony Vrabel
// #warrior = ZephyrFox
// #email = ZephyrFox@hotmail.com
// #web = www.zephyrfox.com
// #credits =
// #readme =
// #config = ZLakHUDOPTGUI
// #include = support/callback.cs
// #include = support/player_support.cs
// #include = support/mute_tools.cs

if(!isObject(ZLakHUD))
{
	new ScriptObject(ZLakHUD)
	{
		class = ZLakHUD;
		version = "1.5";
	};
}

function ZLakHUD::setup(%this)
{
	if(!$ZLakHUD::enable) return;

	callback.add(CallbackMsgMissionDropInfo, "ZLakHUD.dropInfo");
}

function ZLakHUD::dropInfo(%this, %msgType, %msgString, %missionname, %missiontype, %servername)
{
	if(%missiontype $= "lakrabbit")
	{
		callback.add(CallbackmsgPlrPointBonus, "ZLakHUD.clientPointBonus");
		callback.add(CallbackMsgDuelBonus, "ZLakHUD.duelBonus");
		callback.add(CallbackMsgRabbitFlagTaken, "ZLakHUD.flagTaken");

		ZLakHUD.build();
	}
}

function ZLakHUD::build(%this)
{
	new GuiControlProfile ("ZLakHUDPointsProfile")
	{
		fontType = "Arial Bold";
		fontSize = 36;
		fontColor = $ShellColorBright;
		justify = "center";
		autoSizeHeight = true;
	};

	new GuiControlProfile ("ZLakHUDComponentsProfile")
	{
		fontType = "Univers";
		fontSize = 16;
		fontColor = "200 200 200";
		justify = "center";
		autoSizeHeight = true;
	};

	%Hres = getWord($pref::Video::resolution, 0);
	%Vres = getWord($pref::Video::resolution, 1);

	%Xpos = (%Hres/2)-51;
	%Ypos = %Vres-169;

	if(!isObject(LakHUD))
	{
		new GuiControl(LakHUD) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = %Xpos SPC %Ypos;
			extent = "102 100";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellFieldCtrl(ZLakHUDBG) {
				profile = "GuiChatBackProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "102 100";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				fillColor = "0.250000 0.250000 0.250000 1.000000";
				frameColor = "0.000000 1.000000 0.000000 1.000000";
				opacity = "1";

				new GuiTextCtrl(ZLakHUDpoints) {
					profile = "ZLakHUDPointsProfile";
					horizSizing = "center";
					vertSizing = "bottom";
					position = "0 0";
					extent = "60 40";
					minExtent = "8 8";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					text = "";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new HudBitmapCtrl(ZLakHUDtype) {
					profile = "ZLakHUDPointsProfile";
					horizSizing = "center";
					vertSizing = "bottom";
					position = "60 0";
					extent = "40 40";
					minExtent = "8 8";
					visible = "1";
					opacity = ".5";
					bitmap = "";
					autoCenter = "1";
					framecolor = "0 0 0 0.5";
					fillcolor = "0 0 0 0.5";
				};
				new GuiTextCtrl(ZLakHUDslot1) {
					profile = "ZLakHUDComponentsProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "0 35";
					extent = "102 20";
					minExtent = "8 8";
					visible = "0";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					text = "";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new GuiTextCtrl(ZLakHUDslot2) {
					profile = "ZLakHUDComponentsProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "0 50";
					extent = "102 20";
					minExtent = "8 8";
					visible = "0";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					text = "";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new GuiTextCtrl(ZLakHUDslot3) {
					profile = "ZLakHUDComponentsProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "0 65";
					extent = "102 20";
					minExtent = "8 8";
					visible = "0";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					text = "";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new GuiTextCtrl(ZLakHUDslot4) {
					profile = "ZLakHUDComponentsProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "0 80";
					extent = "102 20";
					minExtent = "8 8";
					visible = "0";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					text = "";
					longTextBuffer = "0";
					maxLength = "255";
				};
			};
		};
	}
	playgui.add(LakHUD);

	if(isObject(HM) && isObject(HudMover)) hudmover::addhud(LakHUD, "LakHUD");

	if($ZLakHUD::popUp) LakHUD.setVisible(0);
}

function ZLakHUD::clientPointBonus(%this, %msgType, %msgString, %points, %pluralPoints, %hitType, %weapon, %special, %distance, %speed, %accuracy)
{
	ZLakHUDpoints.setValue(" ");
	ZLakHUDslot1.setValue("  ");
	ZLakHUDslot2.setValue("  ");
	ZLakHUDslot3.setValue("  ");
	ZLakHUDslot4.setValue("  ");

	switch$(%weapon)
	{
		case "Disc": 			%bitmap = "gui/hud_disc.png";
						%accuracy = -1;

		case "Grenade-Launcher": 	%bitmap = "gui/hud_grenlaunch.png";
						%accuracy = -1;

		case "Snipe": 			%bitmap = "gui/hud_sniper.png";
						%accuracy = -1;

		case "Chaingun": 		%bitmap = "gui/hud_chaingun.png";
						%accuracy = getSubStr(%accuracy, 11, 2);

		case "Hand-Nade": 		%bitmap = "gui/hud_handgren.png";
						%accuracy = getSubStr(%accuracy, 11, 2);

		case "Mortar": 			%bitmap = "gui/hud_mortor.png";
						%accuracy = -1;

		case "MINE": 			%bitmap = "gui/hud_mine.png";
						%accuracy = getSubStr(%accuracy, 11, 2);

		case "Blaster": 		%bitmap = "gui/hud_blaster.png";
						%accuracy = -1;

		case "Plasma": 			%bitmap = "gui/hud_plasma.png";
						%accuracy = -1;

		case "ShockLance":		%bitmap = "gui/hud_shocklance.png";
						%accuracy = -1;

	}

	if(%accuracy $= "10") %accuracy = 100;

	ZLakHUDpoints.setValue(%points);
	ZLakHUDslot1.setValue("Distance: " @ %distance @ "M");
	ZLakHUDslot2.setValue("Speed: " @ %speed @ "kph");
	ZLakHUDslot3.setValue("Height: " @ getControlObjectAltitude() @ "M");
	ZLakHUDtype.setBitmap(%bitmap);

	ZLakHUDslot1.setVisible(1);
	ZLakHUDslot2.setVisible(1);
	ZLakHUDslot3.setVisible(1);
	ZLakHUDslot4.setVisible(0);

	ZLakHUDBG.setExtent(100, 85);

	if(%accuracy > 0)
	{
		ZLakHUDslot4.setValue("Accuracy: " @ %accuracy @ "%");
		ZLakHUDslot4.setVisible(1);
		ZLakHUDBG.setExtent(102, 100);
	}

	LakHUD.setVisible(1);

	if($ZLakHUD::popUp)
	{
		if(isEventPending($LakHUD)) cancel($LakHUD);
		$LakHUD = LakHUD.schedule($ZLakHUD::popUpLength, setVisible, 0);
	}
}

function ZLakHUD::duelBonus(%this, %msgType, %msgString, %name, %points, %plural, %kills, %pluralPoints, %seconds, %pluralSeconds)
{
	if(Strstr(%msgString, "bonus point") != -1 && deTag(%name) $= PlayerList.getMyName())
	{
		ZLakHUDpoints.setValue(" ");
		ZLakHUDslot1.setValue("  ");
		ZLakHUDslot2.setValue("  ");
		ZLakHUDslot3.setValue("  ");
		ZLakHUDslot4.setValue("  ");
		

		ZLakHUDpoints.setValue(%points);
		ZLakHUDslot1.setValue("Kills: " @ %kills);
		ZLakHUDslot2.setValue("Seconds: " @ %seconds @ "s");
		ZLakHUDtype.setBitmap("gui/crosshairs.png");

		ZLakHUDslot1.setVisible(1);
		ZLakHUDslot2.setVisible(1);
		ZLakHUDslot3.setVisible(0);
		ZLakHUDslot4.setVisible(0);

		ZLakHUDBG.setExtent(102, 70);

		LakHUD.setVisible(1);

		if($ZLakHUD::popUp)	
		{
			if(isEventPending($LakHUD)) cancel($LakHUD);
			$LakHUD = LakHUD.schedule($ZLakHUD::popUpLength, setVisible, 0);
		}
	}
}

function ZLakHUD::flagTaken(%this, %msgType, %msgString, %name, %points, %speed, %height)
{
	if(Strstr(%msgString, "Mid-Air") != -1 && deTag(%name) $= PlayerList.getMyName())
	{
		ZLakHUDpoints.setValue(" ");
		ZLakHUDslot1.setValue("  ");
		ZLakHUDslot2.setValue("  ");
		ZLakHUDslot3.setValue("  ");
		ZLakHUDslot4.setValue("  ");

		ZLakHUDpoints.setValue(%points);
		ZLakHUDslot1.setValue("Speed: " @ %speed @ "kph");
		ZLakHUDslot2.setValue("Height: " @ %height @ "M");
		ZLakHUDtype.setBitmap("commander/Icons/com_icon_flag_outside.png");

		ZLakHUDslot1.setVisible(1);
		ZLakHUDslot2.setVisible(1);
		ZLakHUDslot3.setVisible(0);
		ZLakHUDslot4.setVisible(0);

		ZLakHUDBG.setExtent(102, 70);

		LakHUD.setVisible(1);

		if($ZLakHUD::popUp)	
		{
			if(isEventPending($LakHUD)) cancel($LakHUD);
			$LakHUD = LakHUD.schedule($ZLakHUD::popUpLength, setVisible, 0);
		}
	}
}

function ZLakHUD::loadPrefs()
{
	if(!$ZLakHUD::loaded)
	{
		exec("prefs/ZLakHUD.prefs");
		$ZLakHUD::loaded = 1;
	}
}

function ZLakHUD::savePrefs()
{
	export("$ZLakHUD::*", "prefs/ZLakHUD.prefs", false);

	if($ZLakHUD::enable) LakHUD.setVisible(1);
	else LakHUD.setVisible(0);

	if($ZLakHUD::popUp && $ZLakHUD::enable) LakHUD.setVisible(0);
	else if($ZLakHUD::enable) LakHUD.setVisible(1);
}

ZLakHUD.loadPrefs();
ZLakHUD.setup();

function ZLakHUDOPTGUI::onWake(%this)
{
	%Hres = getWord($pref::Video::resolution, 0);

	switch(%Hres)
	{
		case 1600:	%HGUIext = 1360;
				%VGUIext = 1073;

				%HPANext = 1340;
				%VPANext = 1053;

				%HSCRext = 1310;
				%VSCRext = 1013;

				%HCONext = 1285;
				%VCONext = 988;

		case 1280:	%HGUIext = 1040;
				%VGUIext = 897;

				%HPANext = 1020;
				%VPANext = 877;

				%HSCRext = 990;
				%VSCRext = 837;

				%HCONext = 965;
				%VCONext = 812;

		case 1024:	%HGUIext = 784;
				%VGUIext = 641;

				%HPANext = 764;
				%VPANext = 621;

				%HSCRext = 734;
				%VSCRext = 581;

				%HCONext = 709;
				%VCONext = 556;

		case 800:	%HGUIext = 560;
				%VGUIext = 473;

				%HPANext = 540;
				%VPANext = 453;

				%HSCRext = 510;
				%VSCRext = 413;

				%HCONext = 485;
				%VCONext = 388;

		default:	%HGUIext = 784;
				%VGUIext = 641;

				%HPANext = 764;
				%VPANext = 621;

				%HSCRext = 734;
				%VSCRext = 581;

				%HCONext = 709;
				%VCONext = 556;
	}

	ZLakHUDOPTGUI.setExtent(%HGUIext, %VGUIext);
	ZLakHUDOPTPane.setExtent(%HPANext, %VPANext);
	ZLakHUDOPTScroll.setExtent(%HSCRext, %VSCRext);
	ZLakHUDOPTContent.setExtent(%HCONext, %VCONext);
}

//--- OBJECT WRITE BEGIN ---
new GuiControl(ZLakHUDOPTGUI) {
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "5 12";
	extent = "0 0";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl(ZLakHUDOPTPane) {
		profile = "ShellPaneProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "0 0";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "ZLakHUD Options";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";
	};
	new ShellScrollCtrl(ZLakHUDOPTScroll) {
		profile = "NewScrollCtrlProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "15 25";
		extent = "0 0";
		minExtent = "24 24";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		willFirstRespond = "1";
		hScrollBar = "dynamic";
		vScrollBar = "dynamic";
		constantThumbHeight = "0";
		defaultLineHeight = "15";
		childMargin = "0 0";
		fieldBase = "gui/shll_field";

		new GuiScrollContentCtrl(ZLakHUDOPTContent) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "4 4";
			extent = "0 0";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new GuiControl(ZLakHUDOPTCanvas) {
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "640 480";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";

				new ShellToggleButton() {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "10 20";
					extent = "140 30";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$ZLakHUD::enable";
					helpTag = "0";
					text = "Enable LakHUD";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellToggleButton() {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "10 45";
					extent = "140 30";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$ZLakHUD::popUp";
					helpTag = "0";
					text = "Popup LakHUD";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellTextEditCtrl() {
					profile = "NewTextEditProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "150 65";
					extent = "74 38";
					minExtent = "32 38";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$ZLakHUD::popUpLength";
					helpTag = "0";
					longTextBuffer = "0";
					maxLength = "255";
					historySize = "0";
					password = "0";
					IRCName = "0";
					tabComplete = "0";
					deniedSound = "InputDeniedSound";
					glowOffset = "9 9";
				};
				new GuiTextCtrl() {
					profile = "GuiTextProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "15 75";
					extent = "100 20";
					minExtent = "8 8";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					text = "Popup length (in ms)";
					longTextBuffer = "0";
					maxLength = "255";
				};
				new ShellBitmapButton() {
					profile = "ShellButtonProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "7 95";
					extent = "100 38";
					minExtent = "32 38";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					command = "ZLakHUD.savePrefs();";
					helpTag = "0";
					text = "Save";
					simpleStyle = "0";
				};
			};
		};
	};
};
//--- OBJECT WRITE END ---